#include <iostream>
#include <string>
#include <time.h> 
#include <math.h>
#include <set>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
#include <vector>

#define NLINE   10000000
#define NCOLUMN 23

using namespace std;

class Line
{
    private:
    double 	L[NCOLUMN];
    
    public:
    Line(void){for(int i=0;i<NCOLUMN;i++) {L[i]=0;}}
    ~Line(void){}
    
    inline double& operator[](int i){return L[i];}
};

bool Compare (Line l1, Line l2) 
{
     if (l1[2]==l2[2]) 
        if ((l1[3]+l1[4])==(l2[3]+l2[4]))
           if (l1[6]==l2[6])
              if (l1[5]==l2[5])
                 return(l1[1]<l2[1]);
              else return(l1[5]<l2[5]);
           else return(l1[6]<l2[6]);
        else return ((l1[3]+l1[4])<(l2[3]+l2[4])); 
     else return(l1[2]<l2[2]);
}

int main()
{
    vector<Line> array;
    vector<Line>::iterator it;
    Line row;
    int c, i, j, k, hn1, hn2, oct, oct1, oct2, ic13, cs, noct;
    long long chord, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, l, time;
    double m2, pcs012, pcs014, pcs016, pcs036;    
    int a[13], oa[13];
    double** coll=new double*[23];
    for (int i=0; i<23; i++)
        coll[i]=new double[10000000];
    double hw[17];
    set<int> aset;
    set<int>::iterator ait; 
    set<int> bset;
    set<int>::iterator bit;  
    
    // Setting the initial values of some of the parameters
    c=0;    
    hn1=0;
    hn2=0;
    oct1=0;
    oct2=0;
    m2=0;
    pcs012=0;
    pcs014=0;
    pcs016=0;
    pcs036=0;
    ic13=0;
    noct=0;
    
    // Setting the harmonic weights
    hw[0]=0;
    hw[1]=1;
    hw[2]=0.5;
    hw[3]=0.3333;
    hw[4]=0.25;
    hw[5]=0.2;
    hw[6]=0.1666;
    hw[7]=0.1428;
    hw[8]=0.125;
    hw[9]=0.1111;
    hw[10]=0.1;
    hw[11]=0.0000;
    hw[12]=0.0000;
    hw[13]=0.0000;
    hw[14]=0.0000;
    hw[15]=0.0000;
    hw[16]=0.0000;
    
    cout<<"Computer is ready to generate and sort all chord configurations with a specific number of chord-tones and a specific chord-span.";
    cout<<endl<<endl<<"Enter the number of chord-tones: ";
    cin>>noct;
    cout<<endl<<"Enter the desired chord-span in semitones: ";
    cin>>cs;
    
    noct=noct-1;
    cs=cs-1;
    
    // Creating all the chords with the desired number of chord-tones and chord-span. No pitch class can be repeated within one chord: (i1, i2, i3, i4, ..., i12) 
    i1=48;
    {
        for (i2=i1+1; i2<(49+cs+12-noct); i2++)                
        {            
            if ((noct<2) || ((i2%12!=i1%12) && (i2%12!=(cs+1+48)%12)))
            {                   
                for (i3=i2+1; i3<(49+cs+12-noct); i3++)                                        
                {
                    if ((noct<3) || ((i3%12!=i1%12) && (i3%12!=i2%12) && (i3%12!=(cs+1+48)%12)))
                    {
                        for (i4=i3+1; i4<(49+cs+12-noct); i4++)                                        
                        {
                            if ((noct<4) || ((i4%12!=i1%12) && (i4%12!=i2%12) && (i4%12!=i3%12) && (i4%12!=(cs+1+48)%12)))
                            {                                               
                                for (i5=i4+1; i5<(49+cs+12-noct); i5++)                                        
                                {
                                    if ((noct<5) || ((i5%12!=i1%12) && (i5%12!=i2%12) && (i5%12!=i3%12) && (i5%12!=i4%12) && (i5%12!=(cs+1+48)%12)))
                                    {                                                                                                                                            
                                        for (i6=i5+1; i6<(49+cs+12-noct); i6++)                                        
                                        {
                                            if ((noct<6) || ((i6%12!=i1%12) && (i6%12!=i2%12) && (i6%12!=i3%12) && (i6%12!=i4%12) && (i6%12!=i5%12) && (i6%12!=(cs+1+48)%12)))
                                            {                                                                                                                                                                                
                                                for (i7=i6+1; i7<(49+cs+12-noct); i7++)                                        
                                                {
                                                    if ((noct<7) || ((i7%12!=i1%12) && (i7%12!=i2%12) && (i7%12!=i3%12) && (i7%12!=i4%12) && (i7%12!=i5%12) && (i7%12!=i6%12) && (i7%12!=(cs+1+48)%12)))
                                                    {                                               
                                                        for (i8=i7+1; i8<(49+cs+12-noct); i8++)                                        
                                                        {
                                                            if ((noct<8) || ((i8%12!=i1%12) && (i8%12!=i2%12) && (i8%12!=i3%12) && (i8%12!=i4%12) && (i8%12!=i5%12) && (i8%12!=i6%12) && (i8%12!=i7%12) && (i8%12!=(cs+1+48)%12)))
                                                            {                                                                                                                                            
                                                                for (i9=i8+1; i9<(49+cs+12-noct); i9++)                                        
                                                                {
                                                                    if ((noct<9) || ((i9%12!=i1%12) && (i9%12!=i2%12) && (i9%12!=i3%12) && (i9%12!=i4%12) && (i9%12!=i5%12) && (i9%12!=i6%12) && (i9%12!=i7%12) && (i9%12!=i8%12) && (i9%12!=(cs+1+48)%12)))
                                                                    {                                                                                                                                                                                        
                                                                        for (i10=i9+1; i10<(49+cs+12-noct); i10++)                                        
                                                                        { 
                                                                            if ((noct<10) || ((i10%12!=i1%12) && (i10%12!=i2%12) && (i10%12!=i3%12) && (i10%12!=i4%12) && (i10%12!=i5%12) && (i10%12!=i6%12) && (i10%12!=i7%12) && (i10%12!=i8%12) && (i10%12!=i9%12) && (i10%12!=(cs+1+48)%12)))
                                                                            {           
                                                                                for (i11=i10+1; i11<(49+cs+12-noct); i11++)                                        
                                                                                {
                                                                                    if ((noct<11) || ((i11%12!=i1%12) && (i11%12!=i2%12) && (i11%12!=i3%12) && (i11%12!=i4%12) && (i11%12!=i5%12) && (i11%12!=i6%12) && (i11%12!=i7%12) && (i11%12!=i8%12) && (i11%12!=i9%12) && (i11%12!=i10%12) && (i11%12!=(cs+1+48)%12)))
                                                                                    {                                                                                                                                                                                        
                                                                                        for (i12=i11+1; i12<(49+cs+12-noct); i12++)                                        
                                                                                        {                                                                                  
                                                                                            if ((noct<12) || ((i12%12!=i1%12) && (i12%12!=i2%12) && (i12%12!=i3%12) && (i12%12!=i4%12) && (i12%12!=i5%12) && (i12%12!=i6%12) && (i12%12!=i7%12) && (i12%12!=i8%12) && (i12%12!=i9%12) && (i12%12!=i10%12) && (i12%12!=i11%12) && (i12%12!=(cs+1+48)%12)))
                                                                                            {                                                                                                    
                                                                                                noct++;
                                                                                                
                                                                                                c++;
                                                                                                                                                                                                                                                                                                
                                                                                                coll[11][c]=i1;
                                                                                                coll[12][c]=i2;
                                                                                                coll[13][c]=i3;
                                                                                                coll[14][c]=i4;
                                                                                                coll[15][c]=i5;
                                                                                                coll[16][c]=i6;
                                                                                                coll[17][c]=i7;
                                                                                                coll[18][c]=i8;
                                                                                                coll[19][c]=i9;
                                                                                                coll[20][c]=i10;
                                                                                                coll[21][c]=i11;
                                                                                                coll[22][c]=i12;
                                                                                                
                                                                                                coll[noct+10][c]=48+1+cs; 
                                                                                                
                                                                                                oa[1]=i1;
                                                                                                oa[2]=i2;
                                                                                                oa[3]=i3;
                                                                                                oa[4]=i4;
                                                                                                oa[5]=i5;
                                                                                                oa[6]=i6;
                                                                                                oa[7]=i7;
                                                                                                oa[8]=i8;
                                                                                                oa[9]=i9;
                                                                                                oa[10]=i10;
                                                                                                oa[11]=i11;
                                                                                                oa[12]=i12;        
                                                                                                
                                                                                                oa[noct]=48+cs+1;                                                                                                                                                                                                          
                                                                                                                        
                                                                                                // Searching for tense trichords and evaluating their significance in the overall tension of each chord
                                                                                                // The effect of the presence of a tense trichord on the overall tension of a complex chord is more significant when the tones of the tense trichord are not too widely spread.                                                                                                
                                                                                                for (i=1; i<(noct+1); i++)
                                                                                                    for (j=i+1; j<(noct+1); j++)
                                                                                                        for (k=j+1; k<(noct+1); k++)                 
                                                                                                        {
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==1)) pcs012=pcs012+1;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==10)) pcs012=pcs012+.75;
                                                                                                            if (((oa[j]-oa[i])==10) && ((oa[k]-oa[j])==1)) pcs012=pcs012+.75;                                                                                                            
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==13)) pcs012=pcs012+.5;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==1)) pcs012=pcs012+.5;
                                                                                                            if (((oa[j]-oa[i])==2) && ((oa[k]-oa[j])==11)) pcs012=pcs012+.37;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==22)) pcs012=pcs012+.5;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==10)) pcs012=pcs012+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==2)) pcs012=pcs012+.37;                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==22) && ((oa[k]-oa[j])==1)) pcs012=pcs012+.5;
                                                                                                            if (((oa[j]-oa[i])==10) && ((oa[k]-oa[j])==13)) pcs012=pcs012+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==11)) pcs012=pcs012+.37;
                                                                                                            
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==3)) pcs014=pcs014+1;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==1)) pcs014=pcs014+1;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==8)) pcs014=pcs014+.75;
                                                                                                            if (((oa[j]-oa[i])==8) && ((oa[k]-oa[j])==3)) pcs014=pcs014+.75;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==8)) pcs014=pcs014+1;
                                                                                                            if (((oa[j]-oa[i])==8) && ((oa[k]-oa[j])==1)) pcs014=pcs014+1;
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==15)) pcs014=pcs014+.5;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==3)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==4) && ((oa[k]-oa[j])==9)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==13)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==4) && ((oa[k]-oa[j])==11)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==15) && ((oa[k]-oa[j])==1)) pcs014=pcs014+.5;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==4)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==20)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==15) && ((oa[k]-oa[j])==8)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==9) && ((oa[k]-oa[j])==4)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==20)) pcs014=pcs014+.5;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==8)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==9)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==8) && ((oa[k]-oa[j])==15)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==20) && ((oa[k]-oa[j])==3)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==9) && ((oa[k]-oa[j])==11)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==8) && ((oa[k]-oa[j])==13)) pcs014=pcs014+.37;
                                                                                                            if (((oa[j]-oa[i])==20) && ((oa[k]-oa[j])==1)) pcs014=pcs014+.5;
                                                                                                            
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==5)) pcs016=pcs016+1;
                                                                                                            if (((oa[j]-oa[i])==5) && ((oa[k]-oa[j])==1)) pcs016=pcs016+1;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==6)) pcs016=pcs016+1;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==1)) pcs016=pcs016+1;
                                                                                                            if (((oa[j]-oa[i])==5) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.75;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==5)) pcs016=pcs016+.75;
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==17)) pcs016=pcs016+.5;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==7)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==5)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==5) && ((oa[k]-oa[j])==13)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==11)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==17) && ((oa[k]-oa[j])==1)) pcs016=pcs016+.5;
                                                                                                            if (((oa[j]-oa[i])==1) && ((oa[k]-oa[j])==18)) pcs016=pcs016+.5;
                                                                                                            if (((oa[j]-oa[i])==7) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.37; 
                                                                                                            if (((oa[j]-oa[i])==13) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==5) && ((oa[k]-oa[j])==18)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==17) && ((oa[k]-oa[j])==6)) pcs016=pcs016+.37;                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==17)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==11) && ((oa[k]-oa[j])==7)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==18) && ((oa[k]-oa[j])==5)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==13)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==7) && ((oa[k]-oa[j])==11)) pcs016=pcs016+.37;
                                                                                                            if (((oa[j]-oa[i])==18) && ((oa[k]-oa[j])==1)) pcs016=pcs016+.5;                                                                                                     
                                                                                                            
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==3)) pcs036=pcs036+1;
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==6)) pcs036=pcs036+.75;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==3)) pcs036=pcs036+.75;
                                                                                                            
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==15)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==9)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==15) && ((oa[k]-oa[j])==3)) pcs036=pcs036+.5;   
                                                                                                            if (((oa[j]-oa[i])==3) && ((oa[k]-oa[j])==20)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==9) && ((oa[k]-oa[j])==6)) pcs036=pcs036+.5;   
                                                                                                            if (((oa[j]-oa[i])==15) && ((oa[k]-oa[j])==6)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==6) && ((oa[k]-oa[j])==15)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==9) && ((oa[k]-oa[j])==9)) pcs036=pcs036+.5;
                                                                                                            if (((oa[j]-oa[i])==18) && ((oa[k]-oa[j])==3)) pcs036=pcs036+.5;                                                                                                                                              
                                                                                                        }
                                                                                                                                                    
                                                                                                // Searching for minor ninths in the in the intervalic content of each chord
                                                                                                for (i=1; i<(noct+1); i++)
                                                                                                    for (j=i+1; j<(noct+1); j++)
                                                                                                    {
                                                                                                        if (oa[j]-oa[i]==13) ic13=ic13+1;
                                                                                                    }                                        
                                                                                                
                                                                                                // Creating a superset of all the harmonic series to search for minor seconds in the intervalic content of this superset
                                                                                                // Repeated tones will appear only once.
                                                                                                for (i=1; i<(noct+1); i++)
                                                                                                {                            
                                                                                                    a[i]=oa[i]%12;                    
                                                                                                
                                                                                                    aset.insert(a[i]);
                                                                                                    aset.insert(a[i]+12);
                                                                                                    aset.insert(a[i]+19);
                                                                                                    aset.insert(a[i]+24);
                                                                                                    /*
                                                                                                    aset.insert(a[i]+28);                                
                                                                                                    aset.insert(a[i]+31);                                
                                                                                                    aset.insert(a[i]+34);
                                                                                                    aset.insert(a[i]+36);
                                                                                                    aset.insert(a[i]+38);
                                                                                                    aset.insert(a[i]+40);
                                                                                                    */                                                        
                                                                                                }
                                                                                                
                                                                                                // Searching for minor seconds in the superset
                                                                                                for (ait=aset.begin(); ait!=aset.end(); ait++)
                                                                                                {
                                                                                                    bit=ait;
                                                                                                    bit++;
                                                                                                    
                                                                                                    if (*bit-*ait==1)                                      
                                                                                                        // Some pitches in the superset belong to more than one harmonic series and can have more than one harmonic weight, in which case we choose the stronger weight.
                                                                                                        for (i=1; i<(noct+1); i++)
                                                                                                        {
                                                                                                            if (*ait==oa[i]%12) {hn1=1; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+12) {hn1=2; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+19) {hn1=3; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+24) {hn1=4; oct1=oa[i]/12;}
                                                                                                            /*
                                                                                                            if (*ait==oa[i]%12+28) {hn1=5; oct1=oa[i]/12;}                                
                                                                                                            if (*ait==oa[i]%12+31) {hn1=6; oct1=oa[i]/12;}                                
                                                                                                            if (*ait==oa[i]%12+34) {hn1=7; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+36) {hn1=8; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+38) {hn1=9; oct1=oa[i]/12;}
                                                                                                            if (*ait==oa[i]%12+40) {hn1=10; oct1=oa[i]/12;}
                                                                                                            */
                                                                                                            
                                                                                                            if (*bit==oa[i]%12) {hn2=1; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+12) {hn2=2; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+19) {hn2=3; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+24) {hn2=4; oct2=oa[i]/12;}
                                                                                                            /*
                                                                                                            if (*bit==oa[i]%12+28) {hn2=5; oct2=oa[i]/12;}                                
                                                                                                            if (*bit==oa[i]%12+31) {hn2=6; oct2=oa[i]/12;}                                
                                                                                                            if (*bit==oa[i]%12+34) {hn2=7; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+36) {hn2=8; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+38) {hn2=9; oct2=oa[i]/12;}
                                                                                                            if (*bit==oa[i]%12+40) {hn2=10; oct2=oa[i]/12;}   
                                                                                                            */                                
                                                                                                        }
                                                                                                    
                                                                                                    // Calculating the total roughness due to the minor seconds
                                                                                                    m2=m2+pow(0.60,oct1-4)*hw[hn1]*pow(0.60,oct2-4)*hw[hn2];
                                                                                                    
                                                                                                    hn1=0;
                                                                                                    hn2=0;                          
                                                                                                }                        
                                                                                                                        
                                                                                                // Creating a collection of chords and their properties                                                                                                
                                                                                                coll[1][c]=m2;
                                                                                                coll[2][c]=pcs012;
                                                                                                coll[3][c]=pcs014;
                                                                                                coll[4][c]=pcs016;
                                                                                                coll[5][c]=pcs036;
                                                                                                coll[6][c]=ic13;                        
                                                                                              
                                                                                                // Resetting the values of some of the parameters before moving on to the next chord
                                                                                                m2=0;
                                                                                                aset.clear();
                                                                                                hn1=0;
                                                                                                hn2=0;
                                                                                                pcs012=0;
                                                                                                pcs014=0;
                                                                                                pcs016=0;
                                                                                                pcs036=0;
                                                                                                ic13=0;    
                                                                                                
                                                                                                noct--;    

                                                                                            } 
                                                                                            if (noct<12) break; 
                                                                                        }                               
                                                                                    }   
                                                                                    if (noct<11) break;
                                                                                }                 
                                                                            } 
                                                                            if (noct<10) break;   
                                                                        }        
                                                                    } 
                                                                    if (noct<9) break;    
                                                                }                                                                                               
                                                            }  
                                                            if (noct<8) break;   
                                                        }                            
                                                    }  
                                                    if (noct<7) break;   
                                                }               
                                            } 
                                            if (noct<6) break;   
                                        }        
                                    }  
                                    if (noct<5) break;  
                                }                                                                                                                            
                            }  
                            if (noct<4) break;   
                        }                            
                    } 
                    if (noct<3) break;    
                }               
            }
            if (noct<2) break;   
        }           
    }

    cout<<endl<<"Done with generating chords, now sorting..."<<endl;
    
    int size=c;
    
    for(int j=1;j<23;j++) row[j]=0;
    array.push_back(row);
    for(int i=1;i<(c+1);i++)
    {
        for(int j=1;j<23;j++) row[j]=coll[j][i];
        
        array.push_back(row);  
    }
    
    sort(array.begin(), array.end(), Compare);
    
    for(int i=1;i<(c+1);i++)
    {
        for(int j=1;j<23;j++) coll[j][i]=array[i][j];
    }
    
    // Printing the sorted chord collection into a file
    ofstream myfile;
    myfile.open ("chordcollection.txt");

    int t1, t2;
    t1=1;
    t2=1;
  
    noct=noct+1;
    
    for (int c=1; c<size+1; c++)
    {              
        oa[1]=coll[11][c];
        oa[2]=coll[12][c];
        oa[3]=coll[13][c];
        oa[4]=coll[14][c];
        oa[5]=coll[15][c]; 
        oa[6]=coll[16][c]; 
        oa[7]=coll[17][c]; 
        oa[8]=coll[18][c]; 
        oa[9]=coll[19][c]; 
        oa[10]=coll[20][c]; 
        oa[11]=coll[21][c]; 
        oa[12]=coll[22][c];
        
        if ((coll[3][c]+coll[4][c])<(coll[3][c-1]+coll[4][c-1])) myfile<<endl;
                   
        if (((coll[3][c]+coll[4][c])!=0) && (t1==1)) 
        {
            t1=0;
            myfile<<endl<<endl<<"pcs(014) or pcs(016)"<<endl;
        }
               
        if (coll[5][c]<coll[5][c-1]) myfile<<endl;
               
        if ((coll[2][c]!=0) && (t2==1))
        {
            t2=0;
            myfile<<endl<<"pcs(012)"<<endl;
        }     
            
        myfile<<endl<<c<<") ";                        
           
        for (i=1; i<(noct+1); i++)
        {           
            if ((oa[i]%12)==0) myfile<<"C";
            if ((oa[i]%12)==1) myfile<<"Db";
            if ((oa[i]%12)==2) myfile<<"D";
            if ((oa[i]%12)==3) myfile<<"Eb";
            if ((oa[i]%12)==4) myfile<<"E";
            if ((oa[i]%12)==5) myfile<<"F";
            if ((oa[i]%12)==6) myfile<<"F#";
            if ((oa[i]%12)==7) myfile<<"G";
            if ((oa[i]%12)==8) myfile<<"Ab";
            if ((oa[i]%12)==9) myfile<<"A";
            if ((oa[i]%12)==10) myfile<<"Bb";
            if ((oa[i]%12)==11) myfile<<"B";            
             
            if ((oa[i]/12)==1) myfile<<"1, ";
            if ((oa[i]/12)==2) myfile<<"2, ";
            if ((oa[i]/12)==3) myfile<<"3, ";
            if ((oa[i]/12)==4) myfile<<"4, ";
            if ((oa[i]/12)==5) myfile<<"5, ";
            if ((oa[i]/12)==6) myfile<<"6, ";
            if ((oa[i]/12)==7) myfile<<"7, ";
            
            if ((oa[i]/12)==0) myfile<<"err, "<<oa[i]<<" ";
        } 
                        
        myfile<<"m2s="<<coll[1][c]<<", ic13="<<coll[6][c]<<", pcs036="<<coll[5][c]<<", pcs014="<<coll[3][c]<<", pcs016="<<coll[4][c]<<", pcs012="<<coll[2][c];
                
    }      
    
    myfile.close();
 
    // Printing the sorted collection into a midi-file readable to human
    // One can convert this file into an actual midi-file readable to notation software by using the "t2mf" application in the command prompt environment.
    myfile.open ("chordcollection_midi.txt");
  
    time=0;
  
    myfile<<"MFile 1 2 1024"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 SMPTE 0 0 0 0 0"<<endl;
    myfile<<"0 TimeSig 1/4 24 8"<<endl;
    myfile<<"0 KeySig 0 major"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 Meta 0x09 "<<"'SmartMusic SoftSynth 1'"<<endl;
    myfile<<"0 Meta TrkName "<<"'Piano'"<<endl;  
    
    for (int c=1; c<size+1; c++)
    {               
        oa[1]=coll[11][c];
        oa[2]=coll[12][c];
        oa[3]=coll[13][c];
        oa[4]=coll[14][c];
        oa[5]=coll[15][c]; 
        oa[6]=coll[16][c]; 
        oa[7]=coll[17][c]; 
        oa[8]=coll[18][c]; 
        oa[9]=coll[19][c]; 
        oa[10]=coll[20][c]; 
        oa[11]=coll[21][c]; 
        oa[12]=coll[22][c];
        
        for (i=1; i<(noct+1); i++)
        {   
            myfile<<time<<" on"<<" ch=1"<<" n="<<oa[i]<<" v=72"<<endl;            
        }                                       
               
        time=time+956;
        
        for (i=1; i<(noct+1); i++)
        {   
            myfile<<time<<" off"<<" ch=1"<<" n="<<oa[i]<<" v=72"<<endl;            
        } 
        
        time=time+68;
        
    }
        
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd";
    
    myfile.close();    
             
    for (int i=0; i<23; i++)
    {
        delete [] coll[i];
    }
    
    delete [] coll;

return 0;
}  

    /*  
    // 0.1^n
    hw[1]=10000;
    hw[2]=1000;
    hw[3]=100;
    hw[4]=10;
    hw[5]=1;
    hw[6]=0.1;
    hw[7]=0.01;
    hw[8]=0.001;
    hw[9]=0.0001;
    hw[10]=0.00001;
    hw[11]=0.0000;
    hw[12]=0.0000;
    hw[13]=0.0000;
    hw[14]=0.0000;
    hw[15]=0.0000;
    hw[16]=0.0000;
    
    // sawtooth wave
    hw[1]=1;
    hw[2]=0.5;
    hw[3]=0.3333;
    hw[4]=0.25;
    hw[5]=0.2;
    hw[6]=0.1666;
    hw[7]=0.1428;
    hw[8]=0.125;
    hw[9]=0.1111;
    hw[10]=0.1;
    hw[11]=0.0000;
    hw[12]=0.0000;
    hw[13]=0.0000;
    hw[14]=0.0000;
    hw[15]=0.0000;
    hw[16]=0.0000;
    
    // piano
    hw[1]=0.95;
    hw[2]=1;
    hw[3]=0.7833;
    hw[4]=0.7666;
    hw[5]=0.7333;
    hw[6]=0.6833;
    hw[7]=0.6333;
    hw[8]=0.6833;
    hw[9]=0.1666;
    hw[10]=0.2833;
    hw[11]=0.0000;
    hw[12]=0.0000;
    hw[13]=0.0000;
    hw[14]=0.0000;
    hw[15]=0.0000;
    hw[16]=0.0000;
        
    // (1/n)^2   
    hw[1]=1;
    hw[2]=0.25;
    hw[3]=0.1111;
    hw[4]=0.0625;
    hw[5]=0.04;
    hw[6]=0.0277;
    hw[7]=0.0204;
    hw[8]=0.0156;
    hw[9]=0.0123;
    hw[10]=0.01;
    hw[11]=0.0000;
    hw[12]=0.0000;
    hw[13]=0.0000;
    hw[14]=0.0000;
    hw[15]=0.0000;
    hw[16]=0.0000;
      
    // piano   
    hw[1]=1;
    hw[2]=0.75;
    hw[3]=0.0769;
    hw[4]=0.0641;
    hw[5]=0.0641;
    hw[6]=0.1153;
    hw[7]=0.1794;
    hw[8]=0.1025;
    hw[9]=0.0128;
    hw[10]=0.0333;
    hw[11]=0.0000;
    hw[12]=0.0000;
    hw[13]=0.0000;
    hw[14]=0.0000;
    hw[15]=0.0000;
    hw[16]=0.0000;
          
    // 1-(n-1)/10    
    hw[1]=1;
    hw[2]=0.9;
    hw[3]=0.8;
    hw[4]=0.7;
    hw[5]=0.6;
    hw[6]=0.5;
    hw[7]=0.4;
    hw[8]=0.3;
    hw[9]=0.2;
    hw[10]=0.1;
    hw[11]=0.0000;
    hw[12]=0.0000;
    hw[13]=0.0000;
    hw[14]=0.0000;
    hw[15]=0.0000;
    hw[16]=0.0000;
    */
