#include <iostream>
#include <string>
#include<time.h> 
#include<math.h>
#include<set>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
#include <vector>

using namespace std;

int main()
{
    int b, e, n, nt, ntt, temp, p1, p2, p3, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11;
    vector<int> prime;
    int t[121][4], s[121];
    set<int> tmset;
    set<int>::iterator tmit; 
    vector< vector<int> > m;
    vector<int> tmvec, a;
    
    cout<<"Computer is ready to generate all melodic configurations that have a specific number of tones with specific beginning and end tones, based on given interlocking trichords.";
    cout<<endl<<"Enter the beginning tone in midi numbers: ";
    cin>>b;
    cout<<endl<<"Enter the end tone in midi numbers: ";
    cin>>e;
    cout<<endl<<"Enter the number of tones (should be an odd number, maximum 11): ";
    cin>>n;    
    cout<<endl<<"How many types of trichords would you like to use as the basis for the melodic lines: ";
    cin>>ntt;

    // Inputting the trichords as pitch-class sets
    for (int i=1; i<(ntt+1); i++) {cout<<endl<<"Enter trichord "<<i<<": "; cin>>temp; prime.push_back(temp); cout<<endl;}
    
    nt=(n-1)/2; // Number of interlocking trichords within a melody

    // Writing all the different melodic variations of the trichords into array 't'
    // 'S' (standing for 'span') is the interval between the first and last tones of each melodic variation of the trichords.
    for (int i=0; i<ntt; i++)
    {
        p1=0;
        p2=prime[i]/10;
        p3=prime[i]%10;
        
        t[1+12*i][1]=p1; t[1+12*i][2]=p2; t[1+12*i][3]=p3; s[1+12*i]=p3;
        t[2+12*i][1]=p1; t[2+12*i][2]=p3; t[2+12*i][3]=p2; s[2+12*i]=p2;
        t[3+12*i][1]=p1; t[3+12*i][2]=p3-p2; t[3+12*i][3]=p3; s[3+12*i]=p3;
        t[4+12*i][1]=p1; t[4+12*i][2]=p3; t[4+12*i][3]=p3-p2; s[4+12*i]=p3-p2;
        t[5+12*i][1]=p1; t[5+12*i][2]=-p2; t[5+12*i][3]=-p3; s[5+12*i]=-p3;
        t[6+12*i][1]=p1; t[6+12*i][2]=-p3; t[6+12*i][3]=-p2; s[6+12*i]=-p2;
        t[7+12*i][1]=p1; t[7+12*i][2]=-(p3-p2); t[7+12*i][3]=-p3; s[7+12*i]=-p3;
        t[8+12*i][1]=p1; t[8+12*i][2]=-p3; t[8+12*i][3]=-(p3-p2); s[8+12*i]=-(p3-p2);
        t[9+12*i][1]=p1; t[9+12*i][2]=p2; t[9+12*i][3]=-(p3-p2); s[9+12*i]=-(p3-p2);
        t[10+12*i][1]=p1; t[10+12*i][2]=-(p3-p2); t[10+12*i][3]=p2; s[10+12*i]=p2;
        t[11+12*i][1]=p1; t[11+12*i][2]=-p2; t[11+12*i][3]=p3-p2; s[11+12*i]=p3-p2;
        t[12+12*i][1]=p1; t[12+12*i][2]=p3-p2; t[12+12*i][3]=-p2; s[12+12*i]=-p2;
    }    

    // Working out the melodic lines based on the given input
    // If possible each melodic variation of the given trichords will only be used once. This is to achieve more variety. 
    int cp=b; // Current position in the process of generating the melodic line in midi numbers

    // For 5-tone melodies
    if (nt==2)
    {
        for (i1=1; i1<(12*ntt+1); i1++)
        {
            tmset.clear();
            tmvec.clear();
            cp=b;
        
            tmset.insert((t[i1][1]+cp)%12); tmset.insert((t[i1][2]+cp)%12); tmset.insert((t[i1][3]+cp)%12);
            tmvec.push_back(t[i1][1]+cp); tmvec.push_back(t[i1][2]+cp);  tmvec.push_back(t[i1][3]+cp);
            cp=cp+s[i1];
                        
            for (i2=1; i2<12*ntt+1; i2++)
            {
                while ((i2<(12*ntt+1)) && (((tmset.find((t[i2][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i2][3]+cp)%12)!=tmset.end()))) i2++;
                if (i2<(12*ntt+1))
                {
                    tmset.insert((t[i2][2]+cp)%12); tmset.insert((t[i2][3]+cp)%12);
                    tmvec.push_back(t[i2][2]+cp); tmvec.push_back(t[i2][3]+cp);
                    cp=cp+s[i2];
                    
                    if ((cp==e) && (tmvec.size()==n)) m.push_back(tmvec); 
                    cp=cp-s[i2]; tmset.erase((t[i2][2]+cp)%12); tmset.erase((t[i2][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                } 
            } 
        }
    }

    // For 7-tone melodies    
    if (nt==3)
    {
        for (i1=1; i1<(12*ntt+1); i1++)
        {
            tmset.clear();            
            tmvec.clear();
            cp=b;                        
            
            tmset.insert((t[i1][1]+cp)%12); tmset.insert((t[i1][2]+cp)%12); tmset.insert((t[i1][3]+cp)%12);
            tmvec.push_back(t[i1][1]+cp); tmvec.push_back(t[i1][2]+cp);  tmvec.push_back(t[i1][3]+cp);
            cp=cp+s[i1];
            
            for (i2=1; i2<12*ntt+1; i2++)            
            {    
                while ((i2<(12*ntt+1)) && (((tmset.find((t[i2][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i2][3]+cp)%12)!=tmset.end()))) i2++;
                if (i2<(12*ntt+1))
                {                                        
                    tmset.insert((t[i2][2]+cp)%12); tmset.insert((t[i2][3]+cp)%12);
                    tmvec.push_back(t[i2][2]+cp); tmvec.push_back(t[i2][3]+cp);
                    cp=cp+s[i2];
                
                    for (i3=1; i3<12*ntt+1; i3++)
                    {
                        while ((i3<(12*ntt+1)) && (((tmset.find((t[i3][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i3][3]+cp)%12)!=tmset.end()))) i3++;
                        if (i3<(12*ntt+1))
                        {                                                     
                            tmset.insert((t[i3][2]+cp)%12); tmset.insert((t[i3][3]+cp)%12);
                            tmvec.push_back(t[i3][2]+cp); tmvec.push_back(t[i3][3]+cp);
                            cp=cp+s[i3];                           
                                                    
                            if ((cp==e) && (tmvec.size()==n)) m.push_back(tmvec); 
                            cp=cp-s[i3]; tmset.erase((t[i3][2]+cp)%12); tmset.erase((t[i3][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                        }            
                    }
                    {cp=cp-s[i2]; tmset.erase((t[i2][2]+cp)%12); tmset.erase((t[i2][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();}
                }    
            } 
        }
    }

    // For 9-tone melodies    
    if (nt==4)
    {
        for (i1=1; i1<(12*ntt+1); i1++)
        {
            tmset.clear();            
            tmvec.clear();
            cp=b;                        
            
            tmset.insert((t[i1][1]+cp)%12); tmset.insert((t[i1][2]+cp)%12); tmset.insert((t[i1][3]+cp)%12);
            tmvec.push_back(t[i1][1]+cp); tmvec.push_back(t[i1][2]+cp);  tmvec.push_back(t[i1][3]+cp);
            cp=cp+s[i1];
            
            for (i2=1; i2<12*ntt+1; i2++)            
            {    
                while ((i2<(12*ntt+1)) && (((tmset.find((t[i2][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i2][3]+cp)%12)!=tmset.end()))) i2++;
                if (i2<(12*ntt+1))
                {                                        
                    tmset.insert((t[i2][2]+cp)%12); tmset.insert((t[i2][3]+cp)%12);
                    tmvec.push_back(t[i2][2]+cp); tmvec.push_back(t[i2][3]+cp);
                    cp=cp+s[i2];
                    
                    for (i3=1; i3<12*ntt+1; i3++)
                    {
                        while ((i3<(12*ntt+1)) && (((tmset.find((t[i3][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i3][3]+cp)%12)!=tmset.end()))) i3++;
                        if (i3<(12*ntt+1))
                        {                                                     
                            tmset.insert((t[i3][2]+cp)%12); tmset.insert((t[i3][3]+cp)%12);
                            tmvec.push_back(t[i3][2]+cp); tmvec.push_back(t[i3][3]+cp);
                            cp=cp+s[i3];                        
                                 
                            for (i4=1; i4<12*ntt+1; i4++)
                            {
                                while ((i4<(12*ntt+1)) && (((tmset.find((t[i4][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i4][3]+cp)%12)!=tmset.end()))) i4++;
                                
                                if (i4<(12*ntt+1))
                                {                                                     
                                    tmset.insert((t[i4][2]+cp)%12); tmset.insert((t[i4][3]+cp)%12);
                                    tmvec.push_back(t[i4][2]+cp); tmvec.push_back(t[i4][3]+cp);
                                    cp=cp+s[i4];                           
                                                            
                                    if ((cp==e) && (tmvec.size()==n)) m.push_back(tmvec); 
                                    cp=cp-s[i4]; tmset.erase((t[i4][2]+cp)%12); tmset.erase((t[i4][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                                }            
                            }
                            cp=cp-s[i3]; tmset.erase((t[i3][2]+cp)%12); tmset.erase((t[i3][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                        }                        
                    }
                    cp=cp-s[i2]; tmset.erase((t[i2][2]+cp)%12); tmset.erase((t[i2][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                }    
            } 
        }
    }

    // For 11-tone melodies   
    if (nt==5)
    {
        for (i1=1; i1<(12*ntt+1); i1++)
        {
            tmset.clear();            
            tmvec.clear();
            cp=b;                        
            
            tmset.insert((t[i1][1]+cp)%12); tmset.insert((t[i1][2]+cp)%12); tmset.insert((t[i1][3]+cp)%12);
            tmvec.push_back(t[i1][1]+cp); tmvec.push_back(t[i1][2]+cp);  tmvec.push_back(t[i1][3]+cp);
            
            cp=cp+s[i1];
            
            for (i2=1; i2<12*ntt+1; i2++)            
            {    
                while ((i2<(12*ntt+1)) && (((tmset.find((t[i2][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i2][3]+cp)%12)!=tmset.end()))) i2++;
                if (i2<(12*ntt+1))
                {                                        
                    tmset.insert((t[i2][2]+cp)%12); tmset.insert((t[i2][3]+cp)%12);
                    tmvec.push_back(t[i2][2]+cp); tmvec.push_back(t[i2][3]+cp);
                    cp=cp+s[i2];
                    
                    for (i3=1; i3<12*ntt+1; i3++)
                    {
                        while ((i3<(12*ntt+1)) && (((tmset.find((t[i3][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i3][3]+cp)%12)!=tmset.end()))) i3++;
                        if (i3<(12*ntt+1))
                        {                                                     
                            tmset.insert((t[i3][2]+cp)%12); tmset.insert((t[i3][3]+cp)%12);
                            tmvec.push_back(t[i3][2]+cp); tmvec.push_back(t[i3][3]+cp);
                            cp=cp+s[i3];                        
                            
                            for (i4=1; i4<12*ntt+1; i4++)
                            {
                                while ((i4<(12*ntt+1)) && (((tmset.find((t[i4][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i4][3]+cp)%12)!=tmset.end()))) i4++;
                                if (i4<(12*ntt+1))
                                {                                                     
                                    tmset.insert((t[i4][2]+cp)%12); tmset.insert((t[i4][3]+cp)%12);
                                    tmvec.push_back(t[i4][2]+cp); tmvec.push_back(t[i4][3]+cp);
                                    cp=cp+s[i4];  
                                         
                                    for (i5=1; i5<12*ntt+1; i5++)
                                    {
                                        while ((i5<(12*ntt+1)) && (((tmset.find((t[i5][2]+cp)%12)!=tmset.end())) || (tmset.find((t[i5][3]+cp)%12)!=tmset.end()))) i5++;
                                        if (i5<(12*ntt+1))
                                        {                                                     
                                            tmset.insert((t[i5][2]+cp)%12); tmset.insert((t[i5][3]+cp)%12);
                                            tmvec.push_back(t[i5][2]+cp); tmvec.push_back(t[i5][3]+cp);
                                            cp=cp+s[i5];                           
                                                                    
                                            if ((cp==e) && (tmvec.size()==n)) m.push_back(tmvec); 
                                            cp=cp-s[i5]; tmset.erase((t[i5][2]+cp)%12); tmset.erase((t[i5][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                                        }            
                                    }
                                    cp=cp-s[i4]; tmset.erase((t[i4][2]+cp)%12); tmset.erase((t[i4][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                                }
                            }
                            cp=cp-s[i3]; tmset.erase((t[i3][2]+cp)%12); tmset.erase((t[i3][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                        }                        
                    }
                    cp=cp-s[i2]; tmset.erase((t[i2][2]+cp)%12); tmset.erase((t[i2][3]+cp)%12); tmvec.pop_back(); tmvec.pop_back();
                }    
            } 
        }
    }
    
    for (int i=0; i<m.size(); i++) {for (int j=0; j<m[i].size(); j++) cout<<m[i][j]<<" "; cout<<endl;}  
    
    // Writing the melodic lines into a file
    ofstream myfile;
    myfile.open ("melodycollection.txt");

    int size=m.size();
    
    for (int c=0; c<size; c++)
    {              
        a.clear();
        
        a.push_back(m[c][0]);
        a.push_back(m[c][1]);
        a.push_back(m[c][2]);
        a.push_back(m[c][3]);
        a.push_back(m[c][4]); 
        a.push_back(m[c][5]); 
        a.push_back(m[c][6]); 
        a.push_back(m[c][7]); 
        a.push_back(m[c][8]); 
        a.push_back(m[c][9]); 
        a.push_back(m[c][10]); 
        
        myfile<<endl<<c+1<<") ";                        
           
        for (int i=0; i<n; i++)
        {           
            if ((a[i]%12)==0) myfile<<"C";
            if ((a[i]%12)==1) myfile<<"Db";
            if ((a[i]%12)==2) myfile<<"D";
            if ((a[i]%12)==3) myfile<<"Eb";
            if ((a[i]%12)==4) myfile<<"E";
            if ((a[i]%12)==5) myfile<<"F";
            if ((a[i]%12)==6) myfile<<"F#";
            if ((a[i]%12)==7) myfile<<"G";
            if ((a[i]%12)==8) myfile<<"Ab";
            if ((a[i]%12)==9) myfile<<"A";
            if ((a[i]%12)==10) myfile<<"Bb";
            if ((a[i]%12)==11) myfile<<"B";            
             
            if ((a[i]/12)==1) myfile<<"1, ";
            if ((a[i]/12)==2) myfile<<"2, ";
            if ((a[i]/12)==3) myfile<<"3, ";
            if ((a[i]/12)==4) myfile<<"4, ";
            if ((a[i]/12)==5) myfile<<"5, ";
            if ((a[i]/12)==6) myfile<<"6, ";
            if ((a[i]/12)==7) myfile<<"7, ";            
        } 
    }      
    
    myfile.close();   

return 0;
}  

