#include <iostream>
#include <string>
#include <time.h> 
#include <math.h>
#include <set>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
#include <vector>
#include <sstream>
#include <iterator>

using namespace std;

int main()
{    
    srand(time(NULL));

    // Inputting the initial rhythmic pattern
    vector<int> rpatt, rhythm;
    int n1, moft1;
    cout<<"How many notes are there in the rhythmic pattern?"<<endl;
    cin>>n1;
    cout<<endl;
    cout<<"Enter the rhythmic pattern in numbers. Press enter after each value:"<<endl; 
    cout<<"1 for sixteenth note, 2 for eighth note and so on."<<endl;
    int temp;
    rpatt.clear();
    rhythm.clear();
    for (int i=0; i<n1; i++)
    {
        cin>>temp;
        rpatt.push_back(temp);
        rhythm.push_back(temp);
    }
    
    int nvti;
    cout<<endl<<"If you choose to insert a note into the rhythmic pattern in each step of transformation, what note-value would that be?"<<endl;
    cin>>nvti;
    
    cout<<endl;
    
    cout<<endl<<"What mode of transformation would you like to use?"<<endl;
    cout<<"1) none"<<endl;
    cout<<"2) in each step the duration of one of the notes increases by a sixteenth note"<<endl;
    cout<<"3) in each step the duration of one of the notes decreases by a sixteenth note"<<endl;
    cout<<"4) both 2 and 3"<<endl;
    cout<<"5) in each step a note with the value specified above will be inserted into the pattern"<<endl;
    cout<<"6) both 4 and 5"<<endl;
    cout<<"7) in each step one of the notes will be removed from the pattern"<<endl;
    cout<<"8) both 4 and 7"<<endl;
    cout<<"9) all"<<endl;
    
    cin>>moft1;
    
    cout<<endl; 

    // Transforming and writing the rhythm into a midi file 
    ofstream myfile;
    
    myfile.open ("rhythmprogression_midi.txt");
  
    int time=0;
  
    myfile<<"MFile 1 2 1024"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 SMPTE 0 0 0 0 0"<<endl;
    myfile<<"0 TimeSig 1/4 24 8"<<endl;
    myfile<<"0 KeySig 0 major"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 Meta 0x09 "<<"'SmartMusic SoftSynth 1'"<<endl;
    myfile<<"0 Meta TrkName "<<"'Piano'"<<endl; 
    
    for (int i=1; i<50; i++)
    {
        int rg1=rand()%moft1;
        
        if (rg1==1) 
        {
            int r1=rand()%rpatt.size();
            rpatt[r1]=rpatt[r1]+1;
        }
        
        if (rg1==2) 
        {
            int r1=rand()%rpatt.size();
            if (rpatt[r1]-1>nvti-1) rpatt[r1]=rpatt[r1]-1;
        }
        
        if (rg1==3)
        {
            int r1=rand()%rpatt.size();
            int r2=rand()%3-1;
            while ((r2==0) || (rpatt[r1]+r2<=nvti-1)) r2=rand()%3-1;
            rpatt[r1]=rpatt[r1]+r2;
        }
        
        if (rg1==4) 
        {
            rpatt.insert(rpatt.begin()+rand()%rpatt.size(),nvti);
        }
        
        if (rg1==5) 
        {
            int r1=rand()%rpatt.size();
            int r2=rand()%3-1;
            while ((r2==0) || (rpatt[r1]+r2<=nvti-1)) r2=rand()%3-1;
            rpatt[r1]=rpatt[r1]+r2;
            
            rpatt.insert(rpatt.begin()+rand()%rpatt.size(),nvti);
        }
        
        if (rg1==6) 
        {
            if (rpatt.size()>1) rpatt.erase(rpatt.begin()+rand()%rpatt.size());
        }
        
        if (rg1==7) 
        {
            int r1=rand()%rpatt.size();
            int r2=rand()%3-1;
            while ((r2==0) || (rpatt[r1]+r2<=nvti-1)) r2=rand()%3-1;
            rpatt[r1]=rpatt[r1]+r2;
            
            if (rpatt.size()>1) rpatt.erase(rpatt.begin()+rand()%rpatt.size());
        }
        
        if (rg1==8)
        {
            int r1=rand()%rpatt.size();
            int r2=rand()%3-1;
            while ((r2==0) || (rpatt[r1]+r2<=nvti-1)) r2=rand()%3-1;
            rpatt[r1]=rpatt[r1]+r2;
            
            int r3=rand()%4;
            if (r3==0) {rpatt.insert(rpatt.begin()+rand()%rpatt.size(),nvti);}
            if ((r3==3) && (rpatt.size()>1)) {rpatt.erase(rpatt.begin()+rand()%rpatt.size());}
        }
        
        for (int j=0; j<rpatt.size(); j++)
        {
            myfile<<time<<" on"<<" ch=1"<<" n="<<71<<" v=72"<<endl; 
            time=time+256*rpatt[j];
            myfile<<time<<" off"<<" ch=1"<<" n="<<71<<" v=0"<<endl; 
            cout<<rpatt[j]<<" ";
            rhythm.push_back(rpatt[j]);
        }
        cout<<endl;
    }
        
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd";
    
    myfile.close();    
    
    cout<<endl;
    
    // Inputting the initial contour pattern
    // The contour pattern can be of the same length as of the rhythmic pattern or it can be shorter or longer creating a kind of isorhythm.
    int n2, moft2;
    vector<int> mc, mctemp;
    vector< vector<int> > contour;
    cout<<"How many notes are there in the contour pattern?"<<endl;
    cin>>n2;
    cout<<endl<<"Enter the contour pattern in numbers (0 being the lowest and the number of notes in the contour pattern minus one being the highest). Press enter after entering each number:"<<endl;
    mc.clear();
    mctemp.clear();
    contour.clear();
    time=0;
    for (int i=0; i<n2; i++)
    {
        cin>>temp;
        mc.push_back(temp);
    }
    
    contour.push_back(mc);
    
    cout<<endl<<"How many modes of transformation would you like to use?"<<endl;
    cout<<"1) only swaps adjacent points in the contour"<<endl;
    cout<<"2) includes repeating a single point in the contour"<<endl;
    cout<<"3) includes retrograding the contour"<<endl;
    cout<<"4) includes inverting the contour"<<endl;
    cin>>moft2;
    
    cout<<endl;

    for (int i=0; i<mc.size(); i++)
    {
        cout<<mc[i]<<" ";
    }
    
    cout<<endl;

    // Transforming and writing the contour into a midi file     
    myfile.open ("contourprogression_midi.txt");
  
    myfile<<"MFile 1 2 1024"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 SMPTE 0 0 0 0 0"<<endl;
    myfile<<"0 TimeSig 1/4 24 8"<<endl;
    myfile<<"0 KeySig 0 major"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 Meta 0x09 "<<"'SmartMusic SoftSynth 1'"<<endl;
    myfile<<"0 Meta TrkName "<<"'Piano'"<<endl;  
    
    for (int i=1; i<50; i++)
    {
        int rg2=rand()%moft2;
        // Swapping adjacent points in the contour
        if (rg2==0)
        {
            int r4=rand()%(n2-1);
            temp=mc[r4];
            mc[r4]=mc[r4+1];
            mc[r4+1]=temp;
        }
        
        // Repeating a single point in the contour
	// These repeated points will be removed before proceeding to the next step of transformation.
        int r5, r6;
        if (rg2==1)
        {
            r5=rand()%mc.size();
            r6=rand()%2+1;
            if (r6==1) mc.insert(mc.begin()+r5,mc[r5]);
            if (r6==2) {mc.insert(mc.begin()+r5,mc[r5]); mc.insert(mc.begin()+r5,mc[r5]);}
        }
              
        // Retrograding the contour
        if (rg2==2)
        {
            for (int j=0; j<mc.size(); j++) mctemp.push_back(mc[j]);
            for (int j=0; j<mc.size(); j++) mc[j]=mctemp[mctemp.size()-j-1];
            mctemp.clear();        
        }
        
        // Inverting the contour
        if (rg2==3)
        {
            for (int j=0; j<mc.size(); j++) mctemp.push_back(mc[j]);
            sort(mctemp.begin(),mctemp.end());
            int b=mctemp[0];
            int e=mctemp[mctemp.size()-1];            
            for (int j=0; j<mc.size(); j++) mc[j]=b+e-mc[j];
            mctemp.clear();
        }
        
        for (int j=0; j<mc.size(); j++)
        {
            cout<<mc[j]<<" ";
            myfile<<time<<" on"<<" ch=1"<<" n="<<mc[j]<<" v=72"<<endl; 
            time=time+256;
            myfile<<time<<" off"<<" ch=1"<<" n="<<mc[j]<<" v=0"<<endl;
        }
        
        contour.push_back(mc);
        
        // Removing the repeated points   
        if (rg2==1)
        {
            if (r6==1) mc.erase(mc.begin()+r5);
            if (r6==2) {mc.erase(mc.begin()+r5); mc.erase(mc.begin()+r5);}            
        }
        
        cout<<endl;
        
    }
        
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd";
    
    myfile.close(); 
    
    time=0;   

    // Writing the combination of rhythm and contour into a midi file     
    myfile.open ("rhythmcontourprogression_midi.txt");
  
    myfile<<"MFile 1 2 1024"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 SMPTE 0 0 0 0 0"<<endl;
    myfile<<"0 TimeSig 1/4 24 8"<<endl;
    myfile<<"0 KeySig 0 major"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 Meta 0x09 "<<"'SmartMusic SoftSynth 1'"<<endl;
    myfile<<"0 Meta TrkName "<<"'Piano'"<<endl;  
    
    int count=0;

    for (int i=0; i<contour.size(); i++)
    {
        for (int j=0; j<contour[i].size(); j++)
        {
            myfile<<time<<" on"<<" ch=1"<<" n="<<contour[i][j]+60<<" v=72"<<endl; 
            time=time+256*rhythm[count];
            count++;
            myfile<<time<<" off"<<" ch=1"<<" n="<<contour[i][j]+60<<" v=0"<<endl;
        }
    }

    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd";
    
    cout<<endl;
    
return 0;
}  
