#include <iostream>
#include <string>
#include <time.h> 
#include <math.h>
#include <set>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
#include <vector>
#include <sstream>
#include <iterator>

using namespace std;

int main()
{
    int temp, cs, nc, nct, sp, bs;
    string line;
    int used[7]={0};
    //set<int> ;
    //set<int>::iterator ; 
    vector< vector<int> > cc, vic, prog;
    vector<int> c, ic, ctemp;
    
    bool first=true;
    bool added=false;
    srand(time(NULL));   

    // Algorithm:
    // Inputting a few basic chords structures in midi notes
    // Reading the soprano and bass voices from text files
    // Creating a vector of the intervalic content for each chord. Each interval and its corresponding tones are stored in one row.
    // Getting a pair of soprano and bass tones
    // Finding a potential chord to be fitted in the soprano bass frame:
	// Converting the desired soprano-bass chord-span into a simple interval and searching for it in the intervallic content of the given chords, to find a chord among the given chords that contains that interval
    // Starting the process of transforming the candidate chord
	// Holding one end of that interval while transposing the other end by a few octaves to comprise the actual compound interval of the desired chord-span. These two tones now form the new boundaries of the chord.
	// Finding the octave transposition that moves the maximum number of the remaining chord-tones into the new boundaries. This ensures that the intervallic structure of the original chord will be optimally preserved.
	// Moving the few chord-tones that are still outside of the new boundary tones to that range by a few additional octave transpositions
	// At last, transposing the transformed chord to the actual soprano-bass framework.
    // Repeating this process for every pair of soprano and bass tones

    cout<<endl<<"How many chord structures would you like to use: ";
    cin>>nc;
    
    cout<<endl<<"How many chord tones are there in each chord: ";
    cin>>nct;
    
    // Inputting the chords
    for (int i=0; i<nc; i++) 
    {
        cout<<endl<<"Enter chord "<<i+1<<" in midi numbers. Press enter after each entry:"<<endl; 
        for (int j=0; j<nct; j++) 
        {
            cin>>temp; c.push_back(temp); cout<<endl;
        }
        cc.push_back(c);
        c.clear();
    }
    
    // Reading the soprano and bass voices from text files
    ifstream input1("soprano.txt");
    vector< vector<int> > soprano;
    vector<int> sptemp;
    string t;
    while (getline(input1,t)) 
    {
        istringstream in (t, istringstream::in);
        copy(istream_iterator<int>(in), istream_iterator<int>(), back_inserter(sptemp));
        soprano.push_back(sptemp);
    }
    
    ifstream input2("bass.txt");
    vector< vector<int> > bass;
    vector<int> bstemp;
    while (getline(input2,t)) 
    {
        istringstream in (t, istringstream::in);
        copy(istream_iterator<int>(in), istream_iterator<int>(), back_inserter(bstemp));
        bass.push_back(bstemp);
    }
        
    int ni=nct*(nct-1)/2;
    int invs=0;
        
    // Creating the vector of intervalic content of all the given chords
    // Intervals greater than a tritone will be stored and marked as inverted. 
    for (int i=0; i<nc; i++) 
    {         
        for (int j=0; j<nct; j++) 
        {    
            for (int k=j+1; k<nct; k++)
            {                
                int temp0=(cc[i][k]-cc[i][j])%12; invs=0;
                if ((cc[i][k]-cc[i][j])%12>6) {temp0=12-(cc[i][k]-cc[i][j])%12; invs=1;}
                ic.push_back(temp0); ic.push_back(i); ic.push_back(j); ic.push_back(k); ic.push_back(invs);
                vic.push_back(ic);
                ic.clear();
            }            
        }
    }
    
    // Sorting the vector of intervalic content
    int flag=1;
    while (flag==1) 
    {
        flag=0;
        for (int i=0; i<vic.size()-1; i++)
        {                
            if ((vic[i][0]%12)>(vic[i+1][0]%12)) 
            {
                int temp1=vic[i][0];
                vic[i][0]=vic[i+1][0];
                vic[i+1][0]=temp1;                         
                                         
                temp1=vic[i][1];
                vic[i][1]=vic[i+1][1];
                vic[i+1][1]=temp1;    
                
                temp1=vic[i][2];
                vic[i][2]=vic[i+1][2];
                vic[i+1][2]=temp1;
                
                temp1=vic[i][3];
                vic[i][3]=vic[i+1][3];
                vic[i+1][3]=temp1; 
                
                temp1=vic[i][4];
                vic[i][4]=vic[i+1][4];
                vic[i+1][4]=temp1; 
                
                flag=1;
            }
        } 
    }
    
    // Getting a pair of soprano and bass tones and finding a potential chord to be fitted in their span
    for (int ip=0; ip<soprano[0].size(); ip++)
    {            
        sp=soprano[0][ip];
        bs=bass[0][ip];    
        
        cs=sp-bs;

        // Finding an interval in the vector of intervalic content that itself or its inversion matched the soprano-bass interval
        added=false;        
        int counter=0;
        int last=0;
        int i=0;
        for (int i=0; i<nc*ni; i++)
            if ((vic[i][0]%12==cs%12) || (vic[i][0]%12==12-cs%12)) {counter++; last=i;}
               
        while (added==false)// vic.size()
        {            
            if (counter!=0) {int R=rand()% counter; i=last-R; used[vic[i][0]%12]++;}  
            if (counter==0) break;

            // This "If" statement checks if the interval found in the vector of intervalic content matches the soprano-bass span and is not marked as inverted, or if its inversion matches the soprano-bass span and is marked as inverted
            if (((vic[i][0]%12==cs%12) && (vic[i][4]==0)) || ((vic[i][0]%12==12-cs%12) && (vic[i][4]==1)))
            {
                added=false;
                ctemp.clear();
                for (int itemp=0; itemp<nct; itemp++) ctemp.push_back(cc[vic[i][1]][itemp]);
                ctemp[vic[i][3]]=ctemp[vic[i][2]]+cs;
                
                int count=0;
                int otmax=-4;
                int lsmax=0;
                
                for (int j=-4; j<5; j++)
                {       
                    for (int k=0; k<nct; k++)
                    {
                        if ((k!=vic[i][2]) && (k!=vic[i][3]) && ((ctemp[k]+j*12)>=ctemp[vic[i][2]]) && ((ctemp[k]+j*12)<=ctemp[vic[i][3]])) count=count+1;
                    }
                    if (count>=lsmax) {lsmax=count; otmax=j;}
                    count=0;
                }
                
                for (int k=0; k<nct; k++)
                {
                    if ((k!=vic[i][2]) && (k!=vic[i][3])) ctemp[k]=ctemp[k]+otmax*12;
                }
                                    
                for (int k=0; k<nct; k++)
                {
                    int flg1=1;
                    int flg2=1;
                    
                    while (ctemp[k]<ctemp[vic[i][2]]) {ctemp[k]=ctemp[k]+12; flg1=0;}
                    
                    if (flg1==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if ((ctemp[k]-ctemp[k1]==1) || (ctemp[k]-ctemp[k1]==-1))
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (((ctemp[k]-ctemp[k2]==1) || (ctemp[k]-ctemp[k2]==-1)) && (k2!=k1))
                                     if ((ctemp[k]+12)<ctemp[vic[i][3]]) {ctemp[k]=ctemp[k]+12; break; k1=0;}
                             }
                    }          
                    
                    if (flg1==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if (ctemp[k]-ctemp[k1]==1)
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (ctemp[k]-ctemp[k2]==2)
                                     if ((ctemp[k]+12)<ctemp[vic[i][3]]) {ctemp[k]=ctemp[k]+12; break; k1=0;}
                             }
                    }        
                    
                    if (flg1==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if (ctemp[k]-ctemp[k1]==-1)
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (ctemp[k]-ctemp[k2]==-2)
                                     if ((ctemp[k]+12)<ctemp[vic[i][3]]) {ctemp[k]=ctemp[k]+12; break; k1=0;}
                             }
                    }                 
                    
                    while (ctemp[k]>ctemp[vic[i][3]]) {ctemp[k]=ctemp[k]-12; flg2=0;}   
                    
                    if (flg2==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if ((ctemp[k]-ctemp[k1]==1) || (ctemp[k]-ctemp[k1]==-1))
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (((ctemp[k]-ctemp[k2]==1) || (ctemp[k]-ctemp[k2]==-1)) && (k2!=k1))
                                     if ((ctemp[k]-12)>ctemp[vic[i][2]]) {ctemp[k]=ctemp[k]-12; break; k1=0;}
                             }
                    }             
                    
                    if (flg2==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if (ctemp[k]-ctemp[k1]==1)
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (ctemp[k]-ctemp[k2]==2)
                                     if ((ctemp[k]-12)>ctemp[vic[i][2]]) {ctemp[k]=ctemp[k]-12; break; k1=0;}
                             }
                    }        
                    
                    if (flg2==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if (ctemp[k]-ctemp[k1]==-1)
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (ctemp[k]-ctemp[k2]==-2)
                                     if ((ctemp[k]-12)>ctemp[vic[i][2]]) {ctemp[k]=ctemp[k]-12; break; k1=0;}
                             }
                    }                                                                           
                }
                
                sort(ctemp.begin(), ctemp.end());       
                
                int low=ctemp[0];
                for (int k=0; k<nct; k++) ctemp[k]=ctemp[k]-low+bs;                
                
                // Checking to make sure that the next pair of soprano and bass tones do not exist in the candidate chord
                int fl=1;
                for (int ii=0; ii<ctemp.size(); ii++)
                {
                    if (ctemp[ii]==soprano[0][ip+1]) fl=0;
                    if (ctemp[ii]==bass[0][ip+1]) fl=0;                    
                }
                
                // Trying to have variety in the chord structures
                if (first==true) {prog.push_back(ctemp); first=false; added=true;}
                else
                {
                    // Checking to see if this exact chord structure has been used before
                    
                    int fflag=1;
                    for (int iprog=0; iprog<prog.size(); iprog++)
                    {
                        int cnst=prog[iprog][0]-ctemp[0]; int flag=0;
                        for (int jprog=0; jprog<prog[iprog].size(); jprog++)
                        {
                            if ((prog[iprog][jprog]-ctemp[jprog])!=cnst) flag=1;
                        }
                        if (flag==0) fflag=0;
                    }
                    
                    if ((fflag==1) && (fl==1)) {prog.push_back(ctemp); added=true;} 
                    else 
                    {
                         if (used[vic[i][0]%12]==counter) {prog.push_back(ctemp); added=true;}
                    }
                }                                          
            }

            // This "If" statement checks if the interval found in the vector of intervalic content matches the inversion of the soprano-bass span and is not marked as inverted, or if it matches the soprano-bass span and is marked as inverted  
            if (((vic[i][0]%12==12-cs%12) && (vic[i][4]==0)) || ((vic[i][0]%12==cs%12) && (vic[i][4]==1))) 
            {
                ctemp.clear();
                for (int itemp=0; itemp<nct; itemp++) ctemp.push_back(cc[vic[i][1]][itemp]);
                ctemp[vic[i][3]]=ctemp[vic[i][2]]-cs;
                
                int count=0;
                int otmax=-4;
                int lsmax=0;
                
                for (int j=-4; j<5; j++)
                {       
                    for (int k=0; k<nct; k++)
                    {
                        if ((k!=vic[i][2]) && (k!=vic[i][3]) && ((ctemp[k]+j*12)<=ctemp[vic[i][2]]) && ((ctemp[k]+j*12)>=ctemp[vic[i][3]])) count=count+1;
                    }       
                    if (count>=lsmax) {lsmax=count; otmax=j;}
                    count=0;
                }
                   
                for (int k=0; k<nct; k++)
                {
                    if ((k!=vic[i][2]) && (k!=vic[i][3])) ctemp[k]=ctemp[k]+otmax*12;                  
                }               
                                         
                for (int k=0; k<nct; k++)
                {
                    int flg1=1;
                    int flg2=1;
                    
                    while (ctemp[k]>ctemp[vic[i][2]]) {ctemp[k]=ctemp[k]-12; flg1=0;}
                    
                    if (flg1==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if ((ctemp[k]-ctemp[k1]==1) || (ctemp[k]-ctemp[k1]==-1))
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (((ctemp[k]-ctemp[k2]==1) || (ctemp[k]-ctemp[k2]==-1)) && (k2!=k1))
                                     if ((ctemp[k]-12)>ctemp[vic[i][3]]) {ctemp[k]=ctemp[k]-12; break; k1=0;}
                             }
                    }           
                    
                    if (flg1==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if (ctemp[k]-ctemp[k1]==1)
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (ctemp[k]-ctemp[k2]==2)
                                     if ((ctemp[k]-12)>ctemp[vic[i][3]]) {ctemp[k]=ctemp[k]-12; break; k1=0;}
                             }
                    }        
                    
                    if (flg1==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if (ctemp[k]-ctemp[k1]==-1)
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (ctemp[k]-ctemp[k2]==-2)
                                     if ((ctemp[k]-12)>ctemp[vic[i][3]]) {ctemp[k]=ctemp[k]-12; break; k1=0;}
                             }
                    }                  
                    
                    while (ctemp[k]<ctemp[vic[i][3]]) {ctemp[k]=ctemp[k]+12; flg2=0;}
                    
                    if (flg2==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if ((ctemp[k]-ctemp[k1]==1) || (ctemp[k]-ctemp[k1]==-1))
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (((ctemp[k]-ctemp[k2]==1) || (ctemp[k]-ctemp[k2]==-1)) && (k2!=k1))
                                     if ((ctemp[k]+12)<ctemp[vic[i][2]]) {ctemp[k]=ctemp[k]+12; break; k1=0;}
                             }
                    }    
                    
                    if (flg2==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if (ctemp[k]-ctemp[k1]==1)
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (ctemp[k]-ctemp[k2]==2)
                                     if ((ctemp[k]+12)<ctemp[vic[i][2]]) {ctemp[k]=ctemp[k]+12; break; k1=0;}
                             }
                    }        
                    
                    if (flg2==0)
                    for (int k1=0; k1<nct; k1++)                       
                    {     
                         if (ctemp[k]-ctemp[k1]==-1)
                             for (int k2=0; k2<nct; k2++)
                             {    
                                 if (ctemp[k]-ctemp[k2]==-2)
                                     if ((ctemp[k]+12)<ctemp[vic[i][2]]) {ctemp[k]=ctemp[k]+12; break; k1=0;}
                             }
                    }                                                                       
                }
                
                sort(ctemp.begin(), ctemp.end());
                
                int low=ctemp[0];
                for (int k=0; k<nct; k++) ctemp[k]=ctemp[k]-low+bs;                
                
                // Checking to make sure that the next pair of soprano and bass tones do not exist in the candidate chord
                int fl=1;
                for (int ii=0; ii<ctemp.size(); ii++)
                {
                    if (ctemp[ii]==soprano[0][ip+1]) fl=0;
                    if (ctemp[ii]==bass[0][ip+1]) fl=0;
                }

		// Trying to have variety in the chord structures
                if (first==true) {prog.push_back(ctemp); first=false; added=true;}
                else
                {
                    int fflag=1;
                    for (int iprog=0; iprog<prog.size(); iprog++)
                    {
                        int cnst=prog[iprog][0]-ctemp[0]; int flag=0;
                        for (int jprog=0; jprog<prog[iprog].size(); jprog++)
                        {
                            if ((prog[iprog][jprog]-ctemp[jprog])!=cnst) flag=1;
                        }
                        if (flag==0) fflag=0;
                    }
                                        
                    if ((fflag==1) && (fl==1)) {prog.push_back(ctemp); added=true;} 
                    else 
                    {
                         if (used[vic[i][0]%12]==counter) {prog.push_back(ctemp); added=true;}
                    }
                }
            }     
        }
        ctemp.clear();
        if (added==false) prog.push_back(ctemp);
    }    
    
    for (int i=0; i<prog.size(); i++)
    {
        for (int j=0; j<prog[i].size(); j++)
        cout<<prog[i][j]<<" "; cout<<endl;
    }

    // Writing the chord progression into a midi file readable to humans.
    ofstream myfile;

    myfile.open ("chordprogression.txt");
  
    int time=0;
  
    myfile<<"MFile 1 2 1024"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 SMPTE 0 0 0 0 0"<<endl;
    myfile<<"0 TimeSig 1/4 24 8"<<endl;
    myfile<<"0 KeySig 0 major"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"0 Tempo 500000"<<endl;
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd"<<endl;
    myfile<<"MTrk"<<endl;
    myfile<<"0 Meta 0x09 "<<"'SmartMusic SoftSynth 1'"<<endl;
    myfile<<"0 Meta TrkName "<<"'Piano'"<<endl;  
    
    int a[12];
    for (int c=0; c<prog.size(); c++)
    {               
        a[0]=prog[c][0];
        a[1]=prog[c][1];
        a[2]=prog[c][2];
        a[3]=prog[c][3];
        a[4]=prog[c][4]; 
        a[5]=prog[c][5]; 
        a[6]=prog[c][6]; 
        a[7]=prog[c][7]; 
        a[8]=prog[c][8]; 
        a[9]=prog[c][9]; 
        a[10]=prog[c][10]; 
        a[11]=prog[c][11];
        
        for (int i=0; i<prog[c].size(); i++)
        {   
            myfile<<time<<" on"<<" ch=1"<<" n="<<a[i]<<" v=72"<<endl;            
        }                                       
               
        time=time+956;
        
        for (int i=0; i<prog[c].size(); i++)
        {   
            myfile<<time<<" off"<<" ch=1"<<" n="<<a[i]<<" v=72"<<endl;            
        } 
        
        time=time+68;
        
    }
        
    myfile<<"21505 Meta TrkEnd"<<endl;
    myfile<<"TrkEnd";
    
    myfile.close();    
 
return 0;
}  

