#include <iostream>
#include <string>
#include <time.h> 
#include <math.h>
#include <set>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
#include <vector>
#include <sstream>
#include <iterator>

using namespace std;

int main()
{
    // Algorithm:
    // Inputting the chord progression
    // Inputting the information on how the chord progression will be divided into different layers (layers can also overlap)
    // Inputting the initial rhythmic pattern for each layer
    // Inputting the initial contour pattern for each layer
    // Transforming the rhythmic and contour patterns, adding ornaments, and applying them to the corresponding layer of the chord progression
    
    srand(time(NULL));
    
    int nol;
    cout<<"To how many layers would you like to divide the progression?"<<endl;
    cin>>nol;   
    cout<<endl;
    cout<<"Refer to voices by numbers. Counting from bottom to top, with bottom voice being 0."<<endl;
    
    int l[10][2];    
    for (int i=0; i<nol; i++) 
    {
        cout<<"Enter the number of the top and bottom voices of layer "<<i+1<<". Press enter after each entry:"<<endl;
        cin>>l[i][1];
        cin>>l[i][2];
        cout<<endl;
    }
    
    // Inputting the chord progression from a file as a 2D vector
    ifstream input1("chordprogression.txt");
    vector< vector<int> > cp;
    vector<int> c;
    string t;
    while (getline(input1,t)) 
    {
        istringstream in (t, istringstream::in);
        copy(istream_iterator<int>(in), istream_iterator<int>(), back_inserter(c));
        cp.push_back(c);
        c.clear();
    }
    
    for (int i=0; i<cp.size(); i++)
    {
        for (int j=0; j<cp[i].size(); j++)
        cout<<cp[i][j]<<" "; cout<<endl;
    }  
    cout<<endl;
    
    int counter=0;
    
    ofstream myfile1;
    
    myfile1.open ("texture_midi.txt");
      
    myfile1<<"MFile 1 "<<nol+1<<" 1024"<<endl;
    myfile1<<"MTrk"<<endl;
    myfile1<<"0 SMPTE 96 0 0 0 0"<<endl;
    myfile1<<"0 TimeSig 1/4 24 8"<<endl;
    myfile1<<"0 KeySig 0 major"<<endl;
    for (int i=0; i<nol; i++) myfile1<<"0 Tempo 500000"<<endl;
    myfile1<<"21505 Meta TrkEnd"<<endl;
    myfile1<<"TrkEnd"<<endl;

    int subdiv;
    double edu;    
    int time=0; 
    int phase;
    
    // Creating the layers one by one
    for (int h=0; h<nol; h++)   
    {
        // Creating the rhythm of each layer
	// Inputting the initial rhythmic pattern
        vector<int> rpatt, rhythm;
        int n1, moft1;
        cout<<"How many notes are there in the rhythmic pattern of layer "<<h+1<<"?"<<endl;
        cin>>n1;
        cout<<endl;
        cout<<"What subdivision of the beat would you like to use for this layer?"<<endl;
        cout<<"Enter 3 for triplet, 4 for sixteenth note, and so on."<<endl;
        cin>>subdiv;        
        edu=1024/subdiv;        
        cout<<endl;        
        cout<<"Enter the rhythmic pattern in numbers. Press enter after each value:"<<endl;
        int temp;
        rpatt.clear();
        rhythm.clear();
        for (int i=0; i<n1; i++)
        {
            cin>>temp;
            rpatt.push_back(temp);
            rhythm.push_back(temp);
        }
        
        int nvti;
	cout<<endl<<"If you choose to insert a note into the rhythmic pattern in each step of transformation, what duration value would you like to use?"<<endl;
        cin>>nvti;        
        cout<<endl;
        
        cout<<endl<<"What mode of transformation would you like to use?"<<endl;
        cout<<"0) none"<<endl;
        cout<<"1) in each step the duration of one of the notes increases by a sixteenth note"<<endl;
        cout<<"2) in each step the duration of one of the notes decreases by a sixteenth note"<<endl;
        cout<<"3) either 1 or 2"<<endl;
        cout<<"4) in each step a note with the value specified above will be inserted into the pattern"<<endl;
        cout<<"5) both 3 and 4"<<endl;
        cout<<"6) in each step one of the notes will be removed from the pattern"<<endl;
        cout<<"7) both 3 and 6"<<endl;
        cout<<"8) all"<<endl;        
        cin>>moft1;        
        cout<<endl;
        
        cout<<"After what time duration from the beginning of the first measure should this rhythmic line start?"<<endl;
        cout<<"Enter 1 for sixteenth note, 2 for eighth note and so on."<<endl;        
        cin>>phase;        
        cout<<endl;

        // Transforming and writing the rhythm into a midi file 
        ofstream myfile2;
        
        myfile2.open ("rhythmprogression_midi.txt");
      
        time=0;
      
        myfile2<<"MFile 1 2 1024"<<endl;
        myfile2<<"MTrk"<<endl;
        myfile2<<"0 SMPTE 0 0 0 0 0"<<endl;
        myfile2<<"0 TimeSig 1/4 24 8"<<endl;
        myfile2<<"0 KeySig 0 major"<<endl;
        myfile2<<"0 Tempo 500000"<<endl;
        myfile2<<"0 Tempo 500000"<<endl;
        myfile2<<"21505 Meta TrkEnd"<<endl;
        myfile2<<"TrkEnd"<<endl;
        myfile2<<"MTrk"<<endl;
        myfile2<<"0 Meta 0x09 "<<"'SmartMusic SoftSynth 1'"<<endl;
        myfile2<<"0 Meta TrkName "<<"'Piano'"<<endl; 
        
        for (int i=1; i<50; i++)
        {            
            // The duration of one of the notes increases by a sixteenth note 
            if (moft1==1) 
            {
                int r1=rand()%rpatt.size();
                rpatt[r1]=rpatt[r1]+1;
            }
            
            // The duration of one of the notes decreases by a sixteenth note
            if (moft1==2) 
            {
                int r1=rand()%rpatt.size();
                if (rpatt[r1]-1>nvti-1) rpatt[r1]=rpatt[r1]-1;
            }
            
            // The duration of one of the notes changes by a sixteenth note
            if (moft1==3)
            {
                int r1=rand()%rpatt.size();
                int r2=rand()%3-1;
                while ((r2==0) || (rpatt[r1]+r2<=nvti-1)) r2=rand()%3-1;
                rpatt[r1]=rpatt[r1]+r2;
            }
            
            // A note will be inserted into the pattern
            if (moft1==4) 
            {
                rpatt.insert(rpatt.begin()+rand()%rpatt.size(),nvti);
            }
            
            // The duration of one of the notes changes by a sixteenth note and a note will be inserted into the pattern
            if (moft1==5) 
            {
                int r1=rand()%rpatt.size();
                int r2=rand()%3-1;
                while ((r2==0) || (rpatt[r1]+r2<=nvti-1)) r2=rand()%3-1;
                rpatt[r1]=rpatt[r1]+r2;
                
                rpatt.insert(rpatt.begin()+rand()%rpatt.size(),nvti);
            }
            
            // One of the notes will be removed from the pattern
            if (moft1==6) 
            {
                if (rpatt.size()>1) rpatt.erase(rpatt.begin()+rand()%rpatt.size());
            }
            
            // The duration of one of the notes changes by a sixteenth note and one of the notes will be removed from the pattern
            if (moft1==7) 
            {
                int r1=rand()%rpatt.size();
                int r2=rand()%3-1;
                while ((r2==0) || (rpatt[r1]+r2<=nvti-1)) r2=rand()%3-1;
                rpatt[r1]=rpatt[r1]+r2;
                
                if (rpatt.size()>1) rpatt.erase(rpatt.begin()+rand()%rpatt.size());
            }
            
            // The duration of one of the notes changes by a sixteenth note and a note will be inserted into or removed from the pattern
            if (moft1==8)
            {
                int r1=rand()%rpatt.size();
                int r2=rand()%3-1;
                while ((r2==0) || (rpatt[r1]+r2<=nvti-1)) r2=rand()%3-1;
                rpatt[r1]=rpatt[r1]+r2;
                
                int r3=rand()%4;
                if (r3==0) {rpatt.insert(rpatt.begin()+rand()%rpatt.size(),nvti);}
                if ((r3==3) && (rpatt.size()>1)) {rpatt.erase(rpatt.begin()+rand()%rpatt.size());}
            }
            
            for (int j=0; j<rpatt.size(); j++)
            {
                myfile2<<time<<" on"<<" ch=1"<<" n="<<71<<" v=72"<<endl; 
                time=time+256*rpatt[j];
                myfile2<<time<<" off"<<" ch=1"<<" n="<<71<<" v=0"<<endl; 
                cout<<rpatt[j]<<" ";
                rhythm.push_back(rpatt[j]);
            }
            cout<<endl;
        }
            
        myfile2<<"21505 Meta TrkEnd"<<endl;
        myfile2<<"TrkEnd";
        
        myfile2.close();          
        cout<<endl;
        
        // Creating the melodic contour of each layer
	// Inputting the initial contour pattern
        int n2;
        int moft2;
        vector<int> mc, mctemp;
        vector< vector<int> > contour;
        cout<<"There are "<<l[h][1]-l[h][2]+1<<" different pitches in layer "<<h+1<<"."<<endl;
        cout<<"How many notes are there in the contour pattern?"<<endl;
        cin>>n2; 
	cout<<endl<<"Enter the contour pattern in numbers (0 being the lowest, and the number of notes in the contour pattern minus one being the highest). Press enter after inputting each number:"<<endl;
        mc.clear();
        mctemp.clear();
        contour.clear();
        time=0;
        for (int i=0; i<n2; i++)
        {
            cin>>temp;
            mc.push_back(temp);
        }
        
        contour.push_back(mc);
        
        cout<<endl<<"How many modes of transformation would you like to use?"<<endl;
        cout<<"1) only swaps adjacent points in the contour"<<endl;
        cout<<"2) includes repeating a single point in the contour"<<endl;
        cout<<"3) includes retrograding the contour"<<endl;
        cout<<"4) includes inverting the contour"<<endl;
        cin>>moft2;        
        cout<<endl;
    
        for (int i=0; i<mc.size(); i++)
        {
            cout<<mc[i]<<" ";
        }        
        cout<<endl;
        
        ofstream myfile3;
        
        myfile3.open ("contourprogression_midi.txt");
      
        myfile3<<"MFile 1 2 1024"<<endl;
        myfile3<<"MTrk"<<endl;
        myfile3<<"0 SMPTE 0 0 0 0 0"<<endl;
        myfile3<<"0 TimeSig 1/4 24 8"<<endl;
        myfile3<<"0 KeySig 0 major"<<endl;
        myfile3<<"0 Tempo 500000"<<endl;
        myfile3<<"0 Tempo 500000"<<endl;
        myfile3<<"21505 Meta TrkEnd"<<endl;
        myfile3<<"TrkEnd"<<endl;
        myfile3<<"MTrk"<<endl;
        myfile3<<"0 Meta 0x09 "<<"'SmartMusic SoftSynth 1'"<<endl;
        myfile3<<"0 Meta TrkName "<<"'Piano'"<<endl;  
        
        for (int i=1; i<50; i++)
        {
            int rmt=rand()%moft2;
            
            // Swapping adjacent points in the contour
            if (rmt==0)
            {
                int r4=rand()%(n2-1);
                temp=mc[r4];
                mc[r4]=mc[r4+1];
                mc[r4+1]=temp;
            }

            // Repeating a single point in the contour
            // These repeated points will be removed before proceeding to the next step of transformation.

            int r5, r6;
            if (rmt==1)
            {
                r5=rand()%mc.size();
                r6=rand()%2+1;
                if (r6==1) mc.insert(mc.begin()+r5,mc[r5]);
                if (r6==2) {mc.insert(mc.begin()+r5,mc[r5]); mc.insert(mc.begin()+r5,mc[r5]);}
            }
                  
            // Retrograding the contour
            if (rmt==2)
            {
                for (int j=0; j<mc.size(); j++) mctemp.push_back(mc[j]);
                for (int j=0; j<mc.size(); j++) mc[j]=mctemp[mctemp.size()-j-1];
                mctemp.clear();        
            }
            
            // Inverting the contour
            if (rmt==3)
            {
                for (int j=0; j<mc.size(); j++) mctemp.push_back(mc[j]);
                sort(mctemp.begin(),mctemp.end());
                int b=mctemp[0];
                int e=mctemp[mctemp.size()-1];            
                for (int j=0; j<mc.size(); j++) mc[j]=b+e-mc[j];
                mctemp.clear();
            }
            
            for (int j=0; j<mc.size(); j++)
            {
                cout<<mc[j]<<" ";
                myfile3<<time<<" on"<<" ch=1"<<" n="<<mc[j]<<" v=72"<<endl; 
                time=time+256;
                myfile3<<time<<" off"<<" ch=1"<<" n="<<mc[j]<<" v=0"<<endl;
            }
            
            contour.push_back(mc);
            
            // Removing the repeated points   
            if (rmt==1)
            {
                if (r6==1) mc.erase(mc.begin()+r5);
                if (r6==2) {mc.erase(mc.begin()+r5); mc.erase(mc.begin()+r5);}            
            }
            
            cout<<endl;
            
        }
            
        myfile3<<"21505 Meta TrkEnd"<<endl;
        myfile3<<"TrkEnd";
        
        myfile3.close();
        cout<<endl;
        
        int orn;        
        cout<<"Would you like to have any ornaments?"<<endl;
        cout<<"Enter 1 for yes, and 0 for no."<<endl;
        cin>>orn;
              
        time=phase*256;

	// Applying the generated rhythm and contour lines to the corresponding layer of the chord progression                             
        myfile1<<"MTrk"<<endl;
        
        myfile1<<"0 Meta 0x09 "<<"\""<<"SmartMusic SoftSynth 1"<<"\""<<endl;
        myfile1<<"0 Meta TrkName "<<"\""<<"layer "<<h+1<<"\""<<endl;  
        myfile1<<"0 PrCh ch="<<h+1<<" p=48"<<endl;
        myfile1<<"0 Par ch="<<h+1<<" c=7"<<" v=101"<<endl;
        myfile1<<"0 Par ch="<<h+1<<" c=10"<<" v="<<15+35*counter<<endl;
        myfile1<<"0 Par ch="<<h+1<<" c=7"<<" v=102"<<endl;
        
        int sum=0;
        for (int i=0; i<rhythm.size(); i++) sum=sum+rhythm[i];
        int average=round(sum/rhythm.size());
                
        counter++;
        
        int count=0;
        int r_orn, r_interval, r_shape;
        int flag1, flag2;
        vector<int> interval, shape;
        interval.clear();
        shape.clear();
        
        for (int i=0; i<cp.size(); i++)
        {
            for (int j=0; j<contour[i].size(); j++)
            {
                r_orn=rand()%8; // 1 out of 8 notes will be ornamented
                
                // Having variety in ornaments
                flag1=1;
                while (flag1==1) 
                {
                    flag1=0;
                    r_interval=rand()%5-2;
                    while (r_interval==0) r_interval=rand()%5-2;
                    for (int k=0; k<interval.size(); k++)
                        if (r_interval==interval[k]) flag1=1;
                }         
                
                flag2=1;
                while (flag2==1) 
                {
                    flag2=0;
                    if (average<5) r_shape=rand()%average;
                    else r_shape=rand()%5;
                    for (int k=0; k<shape.size(); k++)
                        if (r_shape==shape[k]) flag2=1;
                }

		// Generating different types of ornaments while writing the final texture into a file
                if ((orn==1) && (rhythm[count]>1) && (r_orn==0) && (r_shape==0))
                {  
                    interval.push_back(r_interval);
                    shape.push_back(r_shape);
                    if (interval.size()==4) interval.clear();
                    if ((average<5) && (shape.size()==average)) shape.clear(); 
                    if ((average>=5) && (shape.size()==5)) shape.clear();
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl; 
                    time=time+round(edu*rhythm[count])-round(edu/2);
                    count++;
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl; 
                } 
                
                if ((orn==1) && (rhythm[count]>1) && (r_orn==0) && (r_shape==1))
                {  
                    interval.push_back(r_interval);
                    shape.push_back(r_shape);
                    if (interval.size()==4) interval.clear();
                    if ((average<5) && (shape.size()==average)) shape.clear(); 
                    if ((average>=5) && (shape.size()==5)) shape.clear();  
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl; 
                    time=time+round(edu*rhythm[count])-2*round(edu/2);
                    count++;
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl; 
                }           
                
                if ((orn==1) && (rhythm[count]>2) && (r_orn==0) && (r_shape==2))
                {  
                    interval.push_back(r_interval);
                    shape.push_back(r_shape);
                    if (interval.size()==4) interval.clear();
                    if ((average<5) && (shape.size()==average)) shape.clear(); 
                    if ((average>=5) && (shape.size()==5)) shape.clear();  
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl; 
                    time=time+round(edu*rhythm[count])-3*round(edu/2);
                    count++;
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl; 
                }
                
                if ((orn==1) && (rhythm[count]>3) && (r_orn==0) && (r_shape==3))
                {  
                    interval.push_back(r_interval);
                    shape.push_back(r_shape);
                    if (interval.size()==4) interval.clear();
                    if ((average<5) && (shape.size()==average)) shape.clear(); 
                    if ((average>=5) && (shape.size()==5)) shape.clear(); 
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl; 
                    time=time+round(edu*rhythm[count])-4*round(edu/2);
                    count++;
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl; 
                }      
                
                if ((orn==1) && (rhythm[count]>4) && (r_orn==0) && (r_shape==4))
                {  
                    interval.push_back(r_interval);
                    shape.push_back(r_shape);
                    if (interval.size()==4) interval.clear();
                    if ((average<5) && (shape.size()==average)) shape.clear(); 
                    if ((average>=5) && (shape.size()==5)) shape.clear();  
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=72"<<endl;
                    time=time+round(edu/2);
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]+r_interval<<" v=0"<<endl;
                    
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl; 
                    time=time+round(edu*rhythm[count])-5*round(edu/2);
                    count++;
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl; 
                }                       
               
                if ((orn!=1) || (r_orn!=0))
                {                   
                    myfile1<<time<<" on"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=72"<<endl; 
                    time=time+round(edu*rhythm[count]);
                    count++;
                    myfile1<<time<<" off"<<" ch="<<h+1<<" n="<<cp[i][contour[i][j]+l[h][2]]<<" v=0"<<endl;
                }
            }
        }
        
        myfile1<<"21505 Meta TrkEnd"<<endl;
        myfile1<<"TrkEnd"<<endl;
        
        cout<<endl;    
    }
    
    myfile1.close();
    
    system("pause");
    
return 0;
}  
